unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, World, Character, ExtCtrls;

type
  TMainForm = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    FWorld: TWorld;
    FCharacter: TCharacter;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  FWorld := TWorld.Create('Level.cfg');
  FCharacter := TCharacter.Create(FWorld, Image1.Picture, 100, 100);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FWorld.Free;
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  FWorld.Draw(Canvas, 10, 10, 0, 0, FWorld.Width - 1, FWorld.Height - 1);
  FCharacter.Draw(Canvas, 10, 10);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  FCharacter.Tick;
  Invalidate;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_UP then FCharacter.Jump;
  if Key = VK_LEFT then FCharacter.GoLeft;
  if Key = VK_RIGHT then FCharacter.GoRight;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_UP then FCharacter.Fall;
  if (Key = VK_LEFT) or (Key = VK_RIGHT) then FCharacter.Stop;
end;

end.
