unit Tile;

interface

uses
  Graphics, Classes;

type
  TTile = class
  private
    FSolid: Boolean;
    FPicture: TPicture;
    FFriction: Extended;
  public
    constructor Create(aFileName: String; aSolid: Boolean; aFriction: Extended);
    destructor Destroy; override;
    property Solid: Boolean read FSolid;
    property Picture: TPicture read FPicture;
    property Friction: Extended read FFriction;
  end;

implementation

uses
  SysUtils;

{ TTile }

constructor TTile.Create(aFileName: String; aSolid: Boolean; aFriction: Extended);
begin
  aFileName := Trim(aFileName);
  FSolid := aSolid;
  FFriction := aFriction;
  if Length(aFileName) > 0 then
  begin
    FPicture := TPicture.Create;
    FPicture.LoadFromFile(aFileName);
  end;
end;

destructor TTile.Destroy;
begin
  if Assigned(FPicture) then FPicture.Free;
  inherited;
end;

end.
